# TEAM: public_api
openapi: 3.1.0
x-explorer-enabled: false
x-samples-enabled: false
servers:
- description: Flexport API
  url: https://api.flexport.com
info:
  description: >
    The Flexport API enables you to programmatically interact with Flexport's
    freight data.


    The API follows modern RESTful conventions and speaks JSON in both
    directions. As the API uses JSON for both

    requests and responses, we will assume that requests with a payload are
    using properly formatted JSON, however

    we still recommend setting the Content-Type header to the value
    `application/json`
  version: v2
  title: Flexport API
  contact:
    email: hello@flexport.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
tags:
- name: Changelog
  x-traitTag: true
  description: |+
    ## v1 to v2

    ### New Endpoints

    ```
        - POST /booking_amendments
        - GET /booking_line_items
        - POST /booking_line_items
        - GET /booking_line_items/{id}
        - GET /bookings
        - POST /bookings
        - GET /bookings/{id}
        - GET /commercial_invoices
        - GET /commercial_invoices/{id}
        - GET /container_load_results/{id}
        - GET /customs_entries
        - GET /customs_entries/{id}
        - GET /documents
        - POST /documents
        - GET /documents/{id}
        - GET /documents/{id}/download
        - GET /events
        - GET /events/{id}
        - GET /invoices/{id}
        - GET /network/companies
        - POST /network/companies
        - GET /network/companies/{id}
        - PATCH /network/companies/{id}
        - GET /network/company_entities
        - POST /network/company_entities
        - GET /network/company_entities/{id}
        - PATCH /network/company_entities/{id}
        - GET /network/contacts
        - POST /network/contacts
        - GET /network/contacts/{id}
        - PATCH /network/contacts/{id}
        - GET /network/locations
        - POST /network/locations
        - GET /network/locations/{id}
        - PATCH /network/locations/{id}
        - GET /network/me/companies
        - GET /ocean/shipment_container_legs
        - GET /ocean/shipment_container_legs/{id}
        - GET /ocean/shipment_containers
        - GET /ocean/shipment_containers/{id}
        - PATCH /products/{id}
        - GET /purchase_order_line_items
        - GET /purchase_order_line_items/{id}
        - GET /shipment_legs
        - GET /shipment_legs/{id}
        - PATCH /shipments/{id}
        - POST /shipments_shareable
    ```


    ### Modified Endpoints

    ```
        - GET /invoices
          Parameters:
            - Added page
            - Added per
            - Added sort
            - Added direction
            - Added f.status
            - Added f.shipment.id
            - Added f.billed_directly_to_client
            - Added f.entity.id
            - Added f.entity.ref
            - Added f.name
            - Added f.issued_at.gt
            - Added f.issued_at.lt
            - Added f.last_updated_at.gt
            - Added f.last_updated_at.lt
            - Added f.client_id
            - Added f.shipment_id
            - Removed status
          Responses:
            - Modified 200
                - Added _object (string)
                - Added name (string)
                - Added issued_at (string) | format: date-time
                - Added quote_currency_code (string)
                - Added exchange_rate (number)
                - Added balance (object)
                - Added voided_at (string) | format: date-time
                - Added last_updated_at (string) | format: date-time
                - Added recipient (object)
                - Added issuer (object)
                - Added items (array)
                - Added notes (array)
                - Added credit_memos (array)
                - Added shipments (object)
                - Added service_level (['string', 'null'])
                - Added total.properties (unknown type)
                - Removed invoice_id (string)
                - Removed first_shared_at (string)
                - Removed amount_paid (string)
                - Removed currency (string)
                - Removed shipment_id (integer)
                - Removed shipment_name (string)
                - Removed lines (array)
        - GET /ports
          Parameters:
            - Added f.port_type
            - Added f.unlocode
            - Modified page
            - Modified per
            - Removed q
            - Removed port_type
          Responses:
            - Modified 200
                - Added _object (string)
                - Added address (object)
                - Added details (array)
                - Removed id (integer)
                - Removed iata_code (string)
                - Removed lat (['string', 'null'])
                - Removed lng (['string', 'null'])
                - Removed port_name (string)
                - Removed country_code (string)
        - GET /products
          Parameters:
            - Added f.sku
            - Added f.archived_at.exists
            - Added f.product_properties.TYPE
          Responses:
            - Modified 200
                - Added _object (string)
                - Added archived_at (['string', 'null']) | format: date-time
                - Added product_category (string)
                - Added client_verified (boolean)
                - Added classifications (array)
                - Added product_properties.items (object)
                - Added hs_codes.items.properties._object (string)
                - Removed category (string)
        - POST /products
          Responses:
            - Modified 200
                - Added _object (string)
                - Added archived_at (['string', 'null']) | format: date-time
                - Added product_category (string)
                - Added client_verified (boolean)
                - Added classifications (array)
                - Added product_properties.items (object)
                - Added hs_codes.items.properties._object (string)
                - Removed category (string)
        - GET /products/{id}
          Responses:
            - Modified 200
                - Added _object (string)
                - Added archived_at (['string', 'null']) | format: date-time
                - Added product_category (string)
                - Added client_verified (boolean)
                - Added classifications (array)
                - Added product_properties.items (object)
                - Added hs_codes.items.properties._object (string)
                - Removed category (string)
        - GET /purchase_orders
          Parameters:
            - Added page
            - Added per
            - Added sort
            - Added direction
            - Added f.archived_at.exists
            - Added f.status
            - Added f.buyer_ref
            - Added f.seller_ref
            - Added f.role
            - Added f.shipment.id
            - Added f.name
            - Added f.updated_at.lt
            - Added f.updated_at.gt
            - Added f.created_at.lt
            - Added f.created_at.gt
          Responses:
            - Modified 200
                - Added _object (string)
                - Added buyer (object)
                - Added seller (object)
                - Added origin_port (['object', 'null'])
                - Added origin_address (object)
                - Added destination_port (['object', 'null'])
                - Added destination_address (object)
                - Added archived_at (string) | format: date_time
                - Added created_at (string) | format: date_time
                - Added updated_at (string) | format: date_time
                - Added line_items (object)
                - Added metadata (object)
                - Removed role (string) | enums: buyer, seller
                - Removed other_party_ref (string)
                - Removed currency_code (string)
                - Removed origin_port_ref (string)
                - Removed destination_port_ref (string)
                - Removed origin_location_ref (string)
                - Removed destination_location_ref (string)
                - Removed archived (boolean)
                - Removed po_line_items (array)
        - GET /purchase_orders/{id}
          Parameters:
            - Added f.purchase_order_version.id
            - Modified id (type string -> integer)
          Responses:
            - Modified 200
                - Added _object (string)
                - Added buyer (object)
                - Added seller (object)
                - Added origin_port (['object', 'null'])
                - Added origin_address (object)
                - Added destination_port (['object', 'null'])
                - Added destination_address (object)
                - Added archived_at (string) | format: date_time
                - Added created_at (string) | format: date_time
                - Added updated_at (string) | format: date_time
                - Added line_items (object)
                - Added metadata (object)
                - Removed role (string) | enums: buyer, seller
                - Removed other_party_ref (string)
                - Removed currency_code (string)
                - Removed origin_port_ref (string)
                - Removed destination_port_ref (string)
                - Removed origin_location_ref (string)
                - Removed destination_location_ref (string)
                - Removed archived (boolean)
                - Removed po_line_items (array)
        - GET /shipments
          Parameters:
            - Added f.transportation_mode
            - Added f.status
            - Added f.statuses.any
            - Added f.container_number
            - Added f.purchase_order
            - Added f.sku
            - Added f.updated_at.gt
            - Added f.updated_at.lt
            - Added f.archived_at.gt
            - Added f.archived_at.lt
            - Added f.master_bill_number
            - Added f.house_bill_number
            - Added f.consignee_external_ref
            - Added f.origin_address_ref
            - Added f.destination_address_ref
            - Added f.metadata.YOUR_METADATA_KEY
            - Added f.wants_freight_management_bco
            - Added f.wants_flexport_freight
            - Added f.wants_import_customs_service
            - Added f.wants_export_customs_service
            - Added f.wants_commercial_invoice_transcription
            - Added f.wants_flexport_insurance
            - Added f.wants_pickup_service
            - Added f.wants_trade_declaration_service
            - Added f.visibility_only
            - Added f.wants_delivery_service
            - Added f.belongs_to_a_buyers_consol
            - Modified sort (enum ['id', 'updated_at'] -> ['id', 'transportation_mode', 'status', 'updated_at', 'archived_at'])
            - Modified direction
            - Modified page
            - Modified per (type string -> integer)
            - Removed master_bill_number
            - Removed house_bill_number
          Responses:
            - Modified 200
                - Added metadata (object)
                - Added _object (string)
                - Added booking (object)
                - Added it_number (string)
                - Added created_date (string) | format: date-time
                - Added updated_at (string) | format: date-time
                - Added estimated_departure_date (string) | format: date-time
                - Added actual_departure_date (string) | format: date-time
                - Added estimated_arrival_date (string) | format: date-time
                - Added actual_arrival_date (string) | format: date-time
                - Added wants_freight_management_bco (boolean)
                - Added wants_flexport_freight (boolean)
                - Added wants_commercial_invoice_transcription (boolean)
                - Added wants_flexport_insurance (boolean)
                - Added wants_pickup_service (boolean)
                - Added wants_trade_declaration_service (boolean)
                - Added visibility_only (boolean)
                - Added wants_delivery_service (boolean)
                - Added wants_214_filing (boolean)
                - Added wants_ftz_entry (boolean)
                - Added belongs_to_a_buyers_consol (boolean)
                - Added child_shipments (array)
                - Added parent_shipment (object)
                - Added estimated_picked_up_in_full_date (string) | format: date-time
                - Added actual_picked_up_in_full_date (string) | format: date-time
                - Added estimated_delivered_in_full_date (string) | format: date-time
                - Added actual_delivered_in_full_date (string) | format: date-time
                - Added wants_export_customs_service (boolean)
                - Added wants_import_customs_service (boolean)
                - Added ocean_shipment (['object', 'null'])
                - Added air_shipment (['object', 'null'])
                - Added truck_shipment (['object', 'null'])
                - Added dangerous_goods (object)
                - Added accepted_quote (object)
                - Added quoted_transit_time_days_min (number)
                - Added quoted_transit_time_days_max (number)
                - Added quoted_delivery_date_from (string) | format: date-time
                - Added quoted_delivery_date_to (string) | format: date-time
                - Added detention_free_days (integer)
                - Added shipping_order (object)
                - Added shippers (array)
                - Added consignees (array)
                - Added buyers (array)
                - Added sellers (array)
                - Added importers_of_record (array)
                - Added items (array)
                - Added legs (object)
                - Added customs_entries (object)
                - Added documents (object)
                - Added container_load_result (object)
                - Added picked_up_in_full_date (string) | format: date-time
                - Added delivered_in_full_date (string) | format: date-time
                - Added calculated_weight.properties (unknown type)
                - Added calculated_volume.properties (unknown type)
                - Added commercial_invoices.properties (unknown type)
                - Removed flex_id (string)
                - Removed master_bill_number (string)
                - Removed house_bill_number (string)
                - Removed metric_units (boolean)
                - Removed chargeable_weight (string)
                - Removed chargeable_volume (string)
                - Removed archived_at (['string', 'null']) | format: date-time
                - Removed total_weight (string)
                - Removed total_volume (string)
                - Removed origin_pickup_date (string) | format: date-time
                - Removed pickup_date (['string', 'null'])
                - Removed delivery_date (['string', 'null'])
                - Removed containers (array)
                - Removed graph (object)
                - Removed customs_cost (string)
                - Removed origin_address (string)
                - Removed destination_address (string)
                - Removed commercial_invoices.items (object)
        - GET /shipments/{id}
          Responses:
            - Modified 200
                - Added metadata (object)
                - Added _object (string)
                - Added booking (object)
                - Added it_number (string)
                - Added created_date (string) | format: date-time
                - Added updated_at (string) | format: date-time
                - Added estimated_departure_date (string) | format: date-time
                - Added actual_departure_date (string) | format: date-time
                - Added estimated_arrival_date (string) | format: date-time
                - Added actual_arrival_date (string) | format: date-time
                - Added wants_freight_management_bco (boolean)
                - Added wants_flexport_freight (boolean)
                - Added wants_commercial_invoice_transcription (boolean)
                - Added wants_flexport_insurance (boolean)
                - Added wants_pickup_service (boolean)
                - Added wants_trade_declaration_service (boolean)
                - Added visibility_only (boolean)
                - Added wants_delivery_service (boolean)
                - Added wants_214_filing (boolean)
                - Added wants_ftz_entry (boolean)
                - Added belongs_to_a_buyers_consol (boolean)
                - Added child_shipments (array)
                - Added parent_shipment (object)
                - Added estimated_picked_up_in_full_date (string) | format: date-time
                - Added actual_picked_up_in_full_date (string) | format: date-time
                - Added estimated_delivered_in_full_date (string) | format: date-time
                - Added actual_delivered_in_full_date (string) | format: date-time
                - Added wants_export_customs_service (boolean)
                - Added wants_import_customs_service (boolean)
                - Added ocean_shipment (['object', 'null'])
                - Added air_shipment (['object', 'null'])
                - Added truck_shipment (['object', 'null'])
                - Added dangerous_goods (object)
                - Added accepted_quote (object)
                - Added quoted_transit_time_days_min (number)
                - Added quoted_transit_time_days_max (number)
                - Added quoted_delivery_date_from (string) | format: date-time
                - Added quoted_delivery_date_to (string) | format: date-time
                - Added detention_free_days (integer)
                - Added shipping_order (object)
                - Added shippers (array)
                - Added consignees (array)
                - Added buyers (array)
                - Added sellers (array)
                - Added importers_of_record (array)
                - Added items (array)
                - Added legs (object)
                - Added customs_entries (object)
                - Added documents (object)
                - Added container_load_result (object)
                - Added picked_up_in_full_date (string) | format: date-time
                - Added delivered_in_full_date (string) | format: date-time
                - Added calculated_weight.properties (unknown type)
                - Added calculated_volume.properties (unknown type)
                - Added commercial_invoices.properties (unknown type)
                - Removed flex_id (string)
                - Removed master_bill_number (string)
                - Removed house_bill_number (string)
                - Removed metric_units (boolean)
                - Removed chargeable_weight (string)
                - Removed chargeable_volume (string)
                - Removed archived_at (['string', 'null']) | format: date-time
                - Removed total_weight (string)
                - Removed total_volume (string)
                - Removed origin_pickup_date (string) | format: date-time
                - Removed pickup_date (['string', 'null'])
                - Removed delivery_date (['string', 'null'])
                - Removed containers (array)
                - Removed graph (object)
                - Removed customs_cost (string)
                - Removed origin_address (string)
                - Removed destination_address (string)
                - Removed commercial_invoices.items (object)
    ```


    ### Removed Endpoints

    ```
        - GET /currency_codes
        - GET /network
        - POST /network
        - PATCH /network/{id}
        - POST /network/{id}/create_address
        - DELETE /products/{id}
        - POST /products/{id}
        - POST /purchase_orders
        - GET /quote_requests/{id}
    ```

- name: Authentication
  x-traitTag: true
  description: >
    Flexport provides secure access to our public API using OAuth 2.0. We also
    provide granular access controls for

    various resources. This allows the admins of a client account to create
    multiple credentials for different developers or environments.


    A detailed tutorial on how to create and generate credentials [can be
    found
    here.](https://developers.flexport.com/tutorials/using-api-credentials)
- name: Response Semantics
  x-traitTag: true
  description: >
    All responses to authenticated API requests follow the same structure,
    wrapping resource data within an

    `/api/response` object of the following form:


    | Attribute | Description |

    |--------------|-----------|

    | **_object** _string_ | String representing the object’s type. Always
    `/api/response` for this object |

    | **self** _string_ | The full path to the resource(s) requested |

    | **version** _integer_ | The version of the request (see the Versioning
    docs section) |

    | **data** _object_ | The resource data requested for a successful
    response. `null` on error |

    | **error** _object_ | The error object indicating what went wrong (see
    the Errors docs section) |

    | **errors** _list_ | List of legacy error object JSONs of structure
    {"code": _, "message": _} |
- name: Pagination
  x-traitTag: true
  description: >
    All list endpoints return paginated responses. The response object
    contains elements of the current page,

    and links to the previous and next pages.


    | Attribute | Description |

    |--------------|-----------|

    | **_object** _string_ | String representing the object’s type. Always
    `/api/collections/paginated` for this object |

    | **prev** _string_ | link to the previous page |

    | **next** _string_ | link to the next page |

    | **data** _list_ | list of elements in the current page |


    ## Pagination Parameters


    All list endpoint support the following query parameter to retrieve a
    specific page


    | Attribute | Description |

    |--------------|-----------|

    | **page** _integer_ | Page number of the page to retrieve. Defaults to
    page 1. |

    | **per** _integer_ | Count of items in each page. Defaults to 20. Maximum
    allowed value is 100. |
- name: Expansion
  x-traitTag: true
  description: >
    Many resources in the Flexport API contain attributes that are references
    to another resource or a collection of

    resources. For example, a shipment has a reference to a collection of
    legs. Expansion can be used to replace

    those references with the actual data that they represent. This is helpful
    in eliminating subsequent calls

    required to retrieve all data relevant to a resource.


    Expansion is controlled via the expand query parameter. Multiple
    references can be expanded by providing

    multiple items in the expansion array. Expansion may also be recursive,
    i.e. expanded references can be further

    expanded.


    Expansion is valid for both ObjectRef and CollectionRef attributes.


    ## Examples


    Here are some different ways that the expand query parameter can be used
    with the Container API. In the JSON

    examples, some attributes are removed for brevity and replaced with `...`


    ### Example response without expansion

    ```

    curl -X GET  \
      https://api.flexport.com/ocean/shipment_containers/123
    ```


    ```

    {
      "_object": "/api/response",
      "self": "https://api.flexport.com/ocean/shipment_containers/123",
      "version": 2,
      "data": {
          "_object": "/ocean/shipment_container",
          "id": 123,
          ...
          "shipment": {
            "_object": "/api/refs/object",
            "ref_type": "/shipment",
            "link": "https://api.flexport.com/shipments/222",
            "id": 222
          },
          "container_legs": {
            "_object": "/api/refs/collection",
            "ref_type": "/ocean/shipment_container_leg",
            "link": "https://api.flexport.com/ocean/shipment_container_legs?f.shipment_container.id=123"
          },
          ...
      }
    }

    ```


    ### `expand=container_legs`

    The `container_legs` attribute will be expanded into a JSON array of
    `ContainerLeg` objects, instead of the

    normal behavior of the `legs` attribute being a single
    `CollectionRef<ContainerLeg>`


    ```

    curl -X GET  \
      https://api.flexport.com/ocean/shipment_containers/123?expand=container_legs
    ```


    ```

    {
      "_object": "/api/response",
      "self": "https://api.flexport.com/ocean/shipment_containers/123",
      "version": 2,
      "data": {
          "_object": "/ocean/shipment_container",
          "id": 123,
          ...
          "shipment": {
            "_object": "/api/refs/object",
            "ref_type": "/shipment",
            "link": "https://api.flexport.com/shipments/222",
            "id": 222
          },
          "container_legs": {
              "_object": "/api/collections/paginated",
              "prev": null,
              "next": null,
              "total_count": 1,
              "data": [
                  {
                      "_object": "/ocean/shipment_container_leg",
                      "id": 11111,
                      "dates": {},
                      "shipment_container": {
                          "_object": "/api/refs/object",
                          "ref_type": "/ocean/shipment_container",
                          "link": "https://api.flexport.com/ocean/shipment_containers/289140",
                          "id": 289140
                      },
                      "leg": {
                          "_object": "/api/refs/object",
                          "ref_type": "/shipment_leg",
                          "link": "https://api.flexport.com/shipment_legs/4501396",
                          "id": 4501396
                      }
                  }
              ]
          },
          ...
      }
    }

    ```


    ### `expand=container_legs.leg`

    Each `ContainerLeg` object itself contains an `ObjectRef<ShipmentLeg>`,
    and the expand syntax can be chained to

    expand both the `countainer_legs` array, and each `leg` within each
    `ContainerLeg`


    ```

    curl -X GET  \
      https://api.flexport.com/ocean/shipment_containers/123?expand=container_legs.leg
    ```


    ```

    {
      "_object": "/api/response",
      "self": "https://api.flexport.com/ocean/shipment_containers/1234",
      "version": 2,
      "data": {
          "_object": "/ocean/shipment_container",
          "id": 1234,
          ...
          "shipment": {
            "_object": "/api/refs/object",
            "ref_type": "/shipment",
            "link": "https://api.flexport.com/shipments/123",
            "id": 123
          },
          "container_legs": {
              "_object": "/api/collections/paginated",
              "prev": null,
              "next": null,
              "total_count": 1,
              "data": [
                  {
                      "_object": "/ocean/shipment_container_leg",
                      "id": 11111,
                      "dates": {},
                      "shipment_container": {
                          "_object": "/api/refs/object",
                          "ref_type": "/ocean/shipment_container",
                          "link": "https://api.flexport.com/ocean/shipment_containers/289140",
                          "id": 289140
                      },
                      "leg": {
                          "_object": "/shipment_leg",
                          "id": 4501396,
                          "estimated_arrival_date": "2019-05-1T12:00:00.000+08:00",
                          "actual_arrival_date": "2019-05-1T21:52:00.000+08:00"
                          ...
                      }
                  }
              ]
          },
          ...
      }
    }

    ```


    ### `expand=shipment.ocean_shipment.containers`

    Expand out the `shipment` attribute to get a `Shipment` object instead of
    a `ObjectRef<Shipment>` object. Then, a

    `Shipment` object contains an `OceanShipmentDetail`. The
    `OceanShipmentDetail` is not stored as a ref within the

    `Shipment` object, so the full `OceanShipmentDetail` object will be
    returned and does not need to be expanded.

    However, each `OceanShipmentDetail` object contains a
    `CollectionRef<Container>`, and with this syntax that array

    of containers will be expanded out.


    You could use this expansion if you had the `id` of a container, and
    wanted to know all the other containers

    that are on the same shipment.


    ```

    curl -X GET  \
      https://api.flexport.com/ocean/shipment_containers/123?expand=shipment.ocean_shipment.containers
    ```


    ```

    {
      "_object": "/api/response",
      "self": "https://api.flexport.com/ocean/shipment_containers/123",
      "version": 2,
      "data": {
          "_object123 "/ocean/shipment_container",
          "id": 123,
          ...
          "shipment": {
            "_object": "/shipment",
            "id": 222,
            "transportation_mode": "ocean",
            ...
            "ocean_shipment": {
                "_object": "/ocean/shipment",
                ...
                "containers": {
                    "_object": "/api/collections/paginated",
                    "prev": null,
                    "next": null,
                    "total_count": 1,
                    "data": [
                        {
                            "_object": "/ocean/shipment_container",
                            "container_type": "dry",
                            ...
                        }
                    ]
                }
            }
          }
          "container_legs": {
            "_object": "/api/refs/collection",
            "ref_type": "/ocean/shipment_container_leg",
            "link": "https://api.flexport.com/ocean/shipment_container_legs?f.shipment_container.id=123"
          },
          ...
      }
    }

    ```


    ### `expand=container_legs.leg,shipment.ocean_shipment.containers`

    Multiple expansion paths can be passed to the `expand` query parameter.


    ```

    curl -X GET  \
      https://api.flexport.com/ocean/shipment_containers/123?expand=container_legs.leg,shipment.ocean_shipment.containers
    ```


    ```

    {
      "_object": "/api/response",
      "self": "https://api.flexport.com/ocean/shipment_containers/123",
      "version": 2,
      "data": {
          "_object123 "/ocean/shipment_container",
          "id": 123,
          ...
          "shipment": {
            "_object": "/shipment",
            "id": 222,
            "transportation_mode": "ocean",
            ...
            "ocean_shipment": {
                "_object": "/ocean/shipment",
                ...
                "containers": {
                    "_object": "/api/collections/paginated",
                    "prev": null,
                    "next": null,
                    "total_count": 1,
                    "data": [
                        {
                            "_object": "/ocean/shipment_container",
                            "container_type": "dry",
                            ...
                        }
                    ]
                }
            }
          }
          "container_legs": {
              "_object": "/api/collections/paginated",
              "prev": null,
              "next": null,
              "total_count": 1,
              "data": [
                  {
                      "_object": "/ocean/shipment_container_leg",
                      "id": 11111,
                      "dates": {},
                      "shipment_container": {
                          "_object": "/api/refs/object",
                          "ref_type": "/ocean/shipment_container",
                          "link": "https://api.flexport.com/ocean/shipment_containers/289140",
                          "id": 289140
                      },
                      "leg": {
                          "_object": "/shipment_leg",
                          "id": 4501396,
                          "estimated_arrival_date": "2019-05-1T12:00:00.000+08:00",
                          "actual_arrival_date": "2019-05-1T21:52:00.000+08:00"
                          ...
                      }
                  }
              ]
          },
          ...
      }
    }

    ```
- name: Versioning
  x-traitTag: true
  description: >
    Your API version has a large impact on your experience with Flexport's
    APIs. Currently, there are three

    versions available for consumption. You can see your account's current API
    version in your

    [API settings](https://app.flexport.com/account_settings/api) page.


    If you'd like to change your account's API version, please reach out to
    integration support

    (integration-support@flexport.com) for the operation.


    Your account's default API version can always be overridden by passing in
    the `Flexport-Version` header when

    making an API request.


    ## Backwards-compatible changes

    Flexport considers some changes to be non-breaking and will make those
    changes without updating the API version.

    Please follow defensive coding practices in order to ensure stability. We
    consider the following to be

    backwards-compatible changes:

    - Adding an attribute, resource, or optional parameter.

    - Adding a new possible value to an `enum` type attribute.

    - Adding new event types. (Webhook listeners will also receive new events)
- name: Errors
  x-traitTag: true
  description: >
    It may occur that we have issues in understanding or processing your
    request. Under these circumstances,

    the response will resolve with an error object (under the `error`
    attribute) providing insight on what went

    wrong.


    | Attribute | Description |

    |--------------|-----------|

    | **_object** _string_ | String representing the object’s type. Always
    `/api/error` for this object |

    | **status** _integer_ | The HTTP status code (client or server error)
    made available for consumption from the body of the response |

    | **code** _string_ | Specialized identifier for this type of error in our
    API |

    | **message** _string_ | Human readable error message |
- name: Metadata
  x-traitTag: true
  description: >
    Certain resource objects (like Shipments and Containers) have a `metadata`
    attribute in their response

    payloads. Metadata attributes are known as Tags on the user-facing side of
    the application. Metadata is useful

    for storing information on a resource that is not already captured in a
    Flexport-defined field.


    There are two types of metadata formats supported.


    The default metadata format is a key-value hash format where the keys are
    strings, and the values are an

    array of strings.


    ```

    metadata: {color: ["red", "blue"]}

    ```


    An alternate supported format is an array of key defined hashes where the
    keys are `"name"` and `"value"`.


    ```

    metadata: [{name: "color", value: ["red", "blue"]}

    ```


    The response payload for metadata will always display the default metadata
    hash format. To display the

    metadata array format, a URL parameter will need to provided called
    `use_name_value_metadata_format=true`.

    By default, this is false.
- name: Milestones
  x-traitTag: true
  description: >
    This page describes the different event types which will trigger a Event
    object to be sent to your registered Webhook Endpoints.

    Milestones designated with an asterisk are available upon request.


    Document Created and Updated Route require account-level activation by
    Flexport. Additional setup may also be needed for

    Updated Estimated Out for Delivery, Actual Out for Delivery, Loaded on
    Truck, Delivery Complete, and Flexport-generated

    Estimated Available for Pickup.


    To receive these events, contact your Flexport team to confirm
    availability and request setup, and select the relevant

    event category in your webhook settings.


    ## Estimated Transit Events

    For all Estimated Transit Events, the data field of the Event webook
    payload is a Shipment Event Data object.


    |Name|Type|Description|Resource|Location|

    |----|----|----|----|----|

    |Schedule Confirmed|`/shipment#schedule_confirmed`|Estimated departure and
    arrival dates set for each specified
    location.|[Shipment](/v2/tag/ShipmentLeg)|None|

    |Updated Estimated Time of Departure
    (ETD)*|`/shipment_leg#updated_estimated_time_of_departure`|Revised
    estimate of date when shipment will depart from specified
    location.|[ShipmentLeg](/v2/tag/ShipmentLeg)|departure location|

    |Updated Estimated Time of Arrival
    (ETA)*|`/shipment_leg#updated_estimated_time_of_arrival`|Revised estimate
    of date when shipment will arrive at specified
    location.|[ShipmentLeg](/v2/tag/ShipmentLeg)|arrival location|

    |Updated Estimated Out for
    Delivery*|`/shipment_leg#updated_estimated_out_for_delivery`|Revised
    estimate of date when shipment is out for
    delivery.|[ShipmentLeg](/v2/tag/ShipmentLeg)|departure location|

    |Updated Route (This milestone is still under
    development)*|`/shipment#updated_route`|Updated route to final
    destination, such as changes to intermediary locations or
    ports.|[Shipment](/v2/tag/Shipment)|None|

    |Updated Estimated Available for
    Pickup*|`/shipment_container_leg#updated_estimated_available_for_pickup`|Revised
    estimated of date when shipment will be ready for pickup at the port of
    delivery.|[ContainerLeg](/v2/tag/ContainerLeg)|departure location|


    ## Actual Transit Events

    For all Actual Transit Events, the data field of the Event webhook payload
    is a Shipment Event Data object.


    |Name|Type|Description|Resource|Location|

    |----|----|----|----|----|

    |Actual Time of Arrival (ATA)|`/shipment_leg#arrived`|Shipment arrived at
    specified location.|[ShipmentLeg](/v2/tag/ShipmentLeg)|arrival location|

    |Actual Time of Departure (ATD)|`/shipment_leg#departed`|Shipment departed
    from specified location.|[ShipmentLeg](/v2/tag/ShipmentLeg)|departure
    location|

    |Actual Out for Delivery*|`/shipment_leg#out_for_delivery`|Shipment
    departed and is out for
    delivery|[ShipmentLeg](/v2/tag/ShipmentLeg)|departure location|

    |Delivery Complete*|`/shipment_leg#delivery_completed`|Shipment delivery
    is complete|[ShipmentLeg](/v2/tag/ShipmentLeg)|destination location|

    |Loaded on Board*|`/ocean/shipment_container_leg#loaded_on_board`|Shipment
    container loaded on vessel or
    rail.|[ContainerLeg](/v2/tag/ContainerLeg)|where the container was loaded|

    |Loaded on Truck*|`/ocean/shipment_leg#loaded_on_truck`|Cargo has been
    transloaded from shipment container to
    truck.|[ShipmentLeg](/v2/tag/ShipmentLeg)|where the cargo was loaded on
    the truck|

    |Unloaded off
    Board*|`/ocean/shipment_container_leg#unloaded_off_board`|Shipment
    container discharged from vessel or
    rail.|[ContainerLeg](/v2/tag/ContainerLeg)|where the container was
    unloaded|

    |Arrived at Delivery Location|`/shipment_leg#delivered`|Part of a shipment
    delivered to final
    destination.|[ShipmentLeg](/v2/tag/ShipmentLeg)|delivery location|

    |Delivered in Full|`/shipment#delivered_in_full`|Entire shipment delivered
    to final destination, e.g. multi-container
    shipments.|[Shipment](/v2/tag/Shipment)|shipment final destination|


    ## Administrative Events

    For all Administrative Events, the data field of the Event webhook payload
    is a Shipment Event Data object.


    |Name|Type|Description|Resource|Location|

    |----|----|----|----|----|

    |Shipment Created|`/shipment#created`|User has confirmed Flexport quote
    and cargo is getting ready to ship.|[Shipment](/v2/tag/Shipment)|None|

    |Air Booking Confirmed*|`/shipment#booking_confirmed`|Shipment is booked
    with the air carrier.|[Shipment](/v2/tag/Shipment)|None|

    |Updated Cargo Ready Date|`/shipment#cargo_ready_date_changed`|Cargo ready
    date changed from the original cargo ready
    date.|[Shipment](/v2/tag/Shipment)|None|

    |Documents Sent to Nominated
    Broker|`/shipment#documents_sent_to_nominated_broker`|Arrival notice sent
    to client-nominated customs broker. Applicable to non-Flexport customs
    service shipments only.|[Shipment](/v2/tag/Shipment)|None|

    |Commercial Invoices
    Digitized|`/shipments#commercial_invoices_digitized`|All commercial
    invoices have been entered into the Flexport
    system|[Shipment](/v2/tag/Shipment)|None|

    |Container
    Available*|`/ocean/shipment_container_leg#available_for_pickup`|Container
    becomes available for pickup from
    port.|[ContainerLeg](/v2/tag/ContainerLeg)|location of the container|

    |Delivery Appointment
    Requested*|`/shipment_leg#delivery_appointment_requested`|Date the
    delivery appointment was
    requested.|[ShipmentLeg](/v2/tag/ShipmentLeg)|delivery location|

    |Delivery Appointment
    Scheduled|`/shipment_leg#delivery_appointment_scheduled`|Date of the
    scheduled delivery
    appointment.|[ShipmentLeg](/v2/tag/ShipmentLeg)|delivery location|

    |Filing Submitted for in Bond
    Transportation|`/shipment#filing_submitted_for_in_bond_transportation`|Date
    when the filing was submitted.|[Shipment](/v2/tag/Shipment)|None|

    |Free Time to Expire|`/ocean/shipment_container#free_time_to_expire`|Date
    when container [free
    time](https://www.flexport.com/glossary/last-free-day)
    expires.|[Container](/v2/tag/Container)|location of where the container
    will be when the container free time expires|

    |Free Time Expired|`/ocean/shipment_container#free_time_expired`|Date when
    container [free time](https://www.flexport.com/glossary/last-free-day)  expired.|[Container](/v2/tag/Container)|location
    of the container|

    |FTZ Admission|`/shipment#ftz_admission`|Date when carrier is informed
    that the posted bill has been placed on a FTZ
    admission.|[Shipment](/v2/tag/Shipment)|

    |Empty Equipment Returned|`/ocean/shipment_container#empty_returned`|Empty
    container returned to carrier.|[Container](/v2/tag/Container)|location of
    the container|

    |**[DEPRECATED] Delivery Appointment
    Scheduled**|`/shipment_container_leg#delivery_appointment_scheduled`|Date
    and time of the scheduled delivery
    appointment.|[ContainerLeg](/v2/tag/ContainerLeg)|delivery location|

    |Flight Delay: Mechanical Problem|`/shipment#flight_delay_mechanical
    `|Delay due to mechanical issue with the
    airplane.|[Shipment](/v2/tag/Shipment)|

    |Flight Delay: Schedule Updated By
    Carrier|`/shipment#flight_delay_schedule_updated_by_carrier `|Delay due to
    a flight schedule change made by the
    carrier.|[Shipment](/v2/tag/Shipment)|

    |Late Bill of Lading Release|`/shipment#late_bill_of_lading_release
    `|Delay due to late bill of lading release.|[Shipment](/v2/tag/Shipment)|

    |Missed Appointment|`/shipment#missed_appointment `|Delivery not completed
    due to missed appointment.|[Shipment](/v2/tag/Shipment)|

    |Ocean Port Dwell Delay|`/shipment#ocean_port_dwell_delay `|Delay due to
    dwell at ocean port.|[Shipment](/v2/tag/Shipment)|

    |Port Strike Delay|`/shipment#port_strike_delay `|Delay due to port
    strike.|[Shipment](/v2/tag/Shipment)|

    |Vessel Delay: Mechanical  Problem|`/shipment#vessel_delay_mechanical
    `|Delay due to mechanical issue with the
    vessel.|[Shipment](/v2/tag/Shipment)|

    |Warehouse Devan Delay|`/shipment#warehouse_devan_delay `|Delay due to
    warehouse devan.|[Shipment](/v2/tag/Shipment)|

    |(Deconsolidation WH) Schedule delay: Trucking - Pending Linehaul
    Consolidation|`/shipment#_deconsolidation_wh_schedule_delay_trucking_pending_linehaul_consolidation`|(Deconsolidation
    WH) Schedule delay: Trucking - Pending Linehaul
    Consolidation|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Client -  Pending Consignee
    Pickup|`/shipment#_destination_port_dwell_schedule_delay_client_pending_consignee_pickup`|(Destination
    Port Dwell) Schedule delay: Client -  Pending Consignee
    Pickup|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Customs - Customs
    Exam|`/shipment#_destination_port_dwell_schedule_delay_customs_customs_exam`|(Destination
    Port Dwell) Schedule delay: Customs - Customs
    Exam|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Force Majeure -  Weather
    Delay|`/shipment#_destination_port_dwell_schedule_delay_force_majeure_weather_delay`|(Destination
    Port Dwell) Schedule delay: Force Majeure -  Weather
    Delay|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Trucking - Mechanical
    Problem|`/shipment#_destination_port_dwell_schedule_delay_trucking_mechanical_problem`|(Destination
    Port Dwell) Schedule delay: Trucking - Mechanical
    Problem|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Trucking - Operational mistake
    by
    trucker|`/shipment#_destination_port_dwell_schedule_delay_trucking_operational_mistake_by_trucker`|(Destination
    Port Dwell) Schedule delay: Trucking - Operational mistake by
    trucker|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Unavailable  - Container
    Damaged|`/shipment#_destination_port_dwell_schedule_delay_unavailable_container_damaged`|(Destination
    Port Dwell) Schedule delay: Unavailable  - Container
    Damaged|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Unavailable  - Container
    physically inaccessible for
    pickup|`/shipment#_destination_port_dwell_schedule_delay_unavailable_container_physically_inaccessible_for_pickup`|(Destination
    Port Dwell) Schedule delay: Unavailable  - Container physically
    inaccessible for pickup|[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Unavailable  -  No Pickup
    Appointments Available
    |`/shipment#_destination_port_dwell_schedule_delay_unavailable_no_pickup_appointments_available`|(Destination
    Port Dwell) Schedule delay: Unavailable  -  No Pickup Appointments
    Available |[Shipment](/v2/tag/Shipment)|

    |(Destination Port Dwell) Schedule delay: Unavailable  - Unable to
    Locate|`/shipment#_destination_port_dwell_schedule_delay_unavailable_unable_to_locate`|(Destination
    Port Dwell) Schedule delay: Unavailable  - Unable to
    Locate|[Shipment](/v2/tag/Shipment)|

    |(LCL Consolidation) Schedule delay: Client - Unable to load on vessel due
    to shipper or client
    delay|`/shipment#_lcl_consolidation_schedule_delay_client_unable_to_load_on_vessel_due_to_shipper_or_client_delay`|(LCL
    Consolidation) Schedule delay: Client - Unable to load on vessel due to
    shipper or client delay|[Shipment](/v2/tag/Shipment)|

    |(Network Final Delivery) Schedule delay: Client - Warehouse
    Rescheduled|`/shipment#_network_final_delivery_schedule_delay_client_warehouse_rescheduled`|(Network
    Final Delivery) Schedule delay: Client - Warehouse
    Rescheduled|[Shipment](/v2/tag/Shipment)|

    |(Ocean Final Delivery) Schedule delay: Client - Delivery Location
    Changed|`/shipment#_ocean_final_delivery_schedule_delay_client_delivery_location_changed`|(Ocean
    Final Delivery) Schedule delay: Client - Delivery Location
    Changed|[Shipment](/v2/tag/Shipment)|

    |(Ocean Final Delivery) Schedule delay: Customs - Customs
    Exam|`/shipment#_ocean_final_delivery_schedule_delay_customs_customs_exam`|(Ocean
    Final Delivery) Schedule delay: Customs - Customs
    Exam|[Shipment](/v2/tag/Shipment)|

    |(Ocean Final Delivery) Schedule delay: Operator Mistake -
    flexGO|`/shipment#_ocean_final_delivery_schedule_delay_operator_mistake_flexgo`|(Ocean
    Final Delivery) Schedule delay: Operator Mistake -
    flexGO|[Shipment](/v2/tag/Shipment)|

    |(Ocean Final Delivery) Schedule delay: Trucking - Operational mistake by
    trucker|`/shipment#_ocean_final_delivery_schedule_delay_trucking_operational_mistake_by_trucker`|(Ocean
    Final Delivery) Schedule delay: Trucking - Operational mistake by
    trucker|[Shipment](/v2/tag/Shipment)|

    |(Ocean Origin Pickup) Schedule delay: Client - Early pickup/storage
    request  |`/shipment#_ocean_origin_pickup_schedule_delay_client_early_pickup_request`|(Ocean
    Origin Pickup) Schedule delay: Client - Early pickup/storage request  |[Shipment](/v2/tag/Shipment)|

    |(Ocean Origin Pickup) Schedule delay: Other - Please leave detailed
    reasons in
    notes|`/shipment#_ocean_origin_pickup_schedule_delay_other_please_leave_detailed_reasons_in_notes`|(Ocean
    Origin Pickup) Schedule delay: Other - Please leave detailed reasons in
    notes|[Shipment](/v2/tag/Shipment)|

    |(Ocean Origin Pickup) Schedule delay: Trucking - Operational mistake by
    trucker|`/shipment#_ocean_origin_pickup_schedule_delay_trucking_operational_mistake_by_trucker`|(Ocean
    Origin Pickup) Schedule delay: Trucking - Operational mistake by
    trucker|[Shipment](/v2/tag/Shipment)|

    |(Origin Port Dwell) Schedule delay: Carrier - Change of vessel due to
    Port
    Omit|`/shipment#_origin_port_dwell_schedule_delay_carrier_change_of_vessel_due_to_port_omit`|(Origin
    Port Dwell) Schedule delay: Carrier - Change of vessel due to Port
    Omit|[Shipment](/v2/tag/Shipment)|

    |(Origin Port Dwell) Schedule delay: Carrier - Delay in vessel
    departure|`/shipment#_origin_port_dwell_schedule_delay_carrier_delay_in_vessel_departure`|(Origin
    Port Dwell) Schedule delay: Carrier - Delay in vessel
    departure|[Shipment](/v2/tag/Shipment)|

    |(Origin Port Dwell) Schedule delay: Client - Request to hold shipment at
    origin|`/shipment#_origin_port_dwell_schedule_delay_client_request_to_hold_shipment_at_origin`|(Origin
    Port Dwell) Schedule delay: Client - Request to hold shipment at
    origin|[Shipment](/v2/tag/Shipment)|

    |(Origin Port Dwell) Schedule delay: Client - Unable to load on vessel due
    to shipper or client
    delay|`/shipment#_origin_port_dwell_schedule_delay_client_unable_to_load_on_vessel_due_to_shipper_or_client_delay`|(Origin
    Port Dwell) Schedule delay: Client - Unable to load on vessel due to
    shipper or client delay|[Shipment](/v2/tag/Shipment)|

    |(Origin Port Dwell) Schedule delay: Operator
    Mistake|`/shipment#_origin_port_dwell_schedule_delay_operator_mistake`|(Origin
    Port Dwell) Schedule delay: Operator Mistake|[Shipment](/v2/tag/Shipment)|

    |(Origin Port Dwell) Schedule delay: Trucking - Operational mistake by
    trucker|`/shipment#_origin_port_dwell_schedule_delay_trucking_operational_mistake_by_trucker`|(Origin
    Port Dwell) Schedule delay: Trucking - Operational mistake by
    trucker|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - All Documents Received from
    Shipper|`/shipment#all_documents_received_from_shipper`|FID 63495 - All
    Documents Received from Shipper|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Booking Request and Shipper Documents
    Mismatch|`/shipment#booking_request_and_shipper_documents_mismatch`|FID
    63495 - Booking Request and Shipper Documents
    Mismatch|[Shipment](/v2/tag/Shipment)|

    |Cargo Breakdown Delay|`/shipment#cargo_breakdown_delay`|Cargo Breakdown
    Delay|[Shipment](/v2/tag/Shipment)|

    |Cargo Bumped From Booked
    Flight|`/shipment#cargo_bumped_from_booked_flight`|Cargo Bumped From
    Booked Flight|[Shipment](/v2/tag/Shipment)|

    |Cargo Contamination Delay|`/shipment#cargo_contamination_delay`|Cargo
    Contamination Delay|[Shipment](/v2/tag/Shipment)|

    |Cargo Declaration Mismatch|`/shipment#cargo_declaration_mismatch`|Cargo
    Declaration Mismatch|[Shipment](/v2/tag/Shipment)|

    |Cargo Not Available|`/shipment#cargo_not_available`|Cargo Not
    Available|[Shipment](/v2/tag/Shipment)|

    |Cargo Ready Date
    Changed|`/shipment#cargo_ready_date_changed_exception`|Cargo Ready Date
    Changed|[Shipment](/v2/tag/Shipment)|

    |Cargo Ready Date Unknown|`/shipment#cargo_ready_date_unconfirmed`|Cargo
    Ready Date Unknown|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Cargo Received After
    Cutoff|`/shipment#cargo_received_after_cutoff`|FID 63495 - Cargo Received
    After Cutoff|[Shipment](/v2/tag/Shipment)|

    |Cargo Rolled from Booked
    Vessel|`/shipment#cargo_rolled_from_booked_vessel`|Cargo Rolled from
    Booked Vessel|[Shipment](/v2/tag/Shipment)|

    |Carrier Refused/Bumped DG
    Shipment|`/shipment#carrier_refused_bumped_dg_shipment`|Carrier
    Refused/Bumped DG Shipment|[Shipment](/v2/tag/Shipment)|

    |Flight Delay: Congestion at Transit
    Port|`/shipment#congestion_at_transit_port`|Flight Delay: Congestion at
    Transit Port|[Shipment](/v2/tag/Shipment)|

    |Consignee related House Bill of Lading release
    delay|`/shipment#consignee_related_house_bill_of_lading_release_delay`|Consignee
    related House Bill of Lading release delay|[Shipment](/v2/tag/Shipment)|

    |Carrier Freight Hold|`/shipment#container_carrier_hold`|Carrier Freight
    Hold|[Shipment](/v2/tag/Shipment)|

    |Container Hold: Customs|`/shipment#container_customs_hold`|Container
    Hold: Customs|[Shipment](/v2/tag/Shipment)|

    |Discharge Delay at Rail
    Yard|`/shipment#container_discharge_delay`|Discharge Delay at Rail
    Yard|[Shipment](/v2/tag/Shipment)|

    |Container Hold: Other|`/shipment#container_hold_other`|Container Hold:
    Other|[Shipment](/v2/tag/Shipment)|

    |Shipment Under Consumer Product Safety Commission (CPSC) Review - Hold
    Cargo Intact|`/shipment#cpsc_hold`|Shipment Under Consumer Product Safety
    Commission (CPSC) Review - Hold Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |CPSC Hold Removed|`/shipment#cpsc_hold_removed`|CPSC Hold
    Removed|[Shipment](/v2/tag/Shipment)|

    |Shipment Under Customs Agricultural Hold - Hold Cargo
    Intact|`/shipment#customs_agriculture_hold`|Shipment Under Customs
    Agricultural Hold - Hold Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |Shipment Under Customs Agricultural Exam - Hold Cargo
    Intact|`/shipment#customs_agriculture_hold_exam`|Shipment Under Customs
    Agricultural Exam - Hold Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |Customs Agriculture Hold
    Removed|`/shipment#customs_agriculture_hold_removed`|Customs Agriculture
    Hold Removed|[Shipment](/v2/tag/Shipment)|

    |Release Status Change: Pending Intensive
    Exam|`/shipment#customs_entry_release_status_pending_intensive_exam`|Release
    Status Change: Pending Intensive Exam|[Shipment](/v2/tag/Shipment)|

    |Customs entry
    released|`/shipment#customs_entry_release_status_released`|Customs entry
    released|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Customs Hold: Contains Goods with Export
    Restrictions|`/shipment#customs_hold_contains_goods_with_export_restrictions`|FID
    63495 - Customs Hold: Contains Goods with Export
    Restrictions|[Shipment](/v2/tag/Shipment)|

    |Delivery Appointment
    Confirmed|`/shipment#delivery_appointment_confirmed`|Delivery Appointment
    Confirmed|[Shipment](/v2/tag/Shipment)|

    |Delivery Appointment
    Updated|`/shipment#delivery_appointment_updated`|Delivery Appointment
    Updated|[Shipment](/v2/tag/Shipment)|

    |Delivery Cancelled: Wrong Delivery
    Address|`/shipment#delivery_cancelled_wrong_delivery_address`|Delivery
    Cancelled: Wrong Delivery Address|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Delivery Delay|`/shipment#delivery_delay`|FID 63495 -
    Delivery Delay|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Delivery Location Not
    Accessible|`/shipment#delivery_location_not_accessible`|FID 63495 -
    Delivery Location Not Accessible|[Shipment](/v2/tag/Shipment)|

    |Demurrage (Storage)
    Incurred|`/shipment#demurrage_storage_incurred`|Demurrage (Storage)
    Incurred|[Shipment](/v2/tag/Shipment)|

    |Discharge Delay at Ocean
    Port|`/shipment#discharge_delay_at_ocean_port`|Discharge Delay at Ocean
    Port|[Shipment](/v2/tag/Shipment)|

    |Dry Run: Delivery Attempt Not
    Completed|`/shipment#dry_run_delivery_attempt_not_completed`|Dry Run:
    Delivery Attempt Not Completed|[Shipment](/v2/tag/Shipment)|

    |Dry Run: Delivery Location
    Closed|`/shipment#dry_run_delivery_location_closed`|Dry Run: Delivery
    Location Closed|[Shipment](/v2/tag/Shipment)|

    |Dry Run: Delivery Refused by
    Consignee|`/shipment#dry_run_delivery_refused_by_consignee`|Dry Run:
    Delivery Refused by Consignee|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Dry Run: Improper Equipment for
    Delivery|`/shipment#dry_run_improper_equipment_for_delivery`|FID 63495 -
    Dry Run: Improper Equipment for Delivery|[Shipment](/v2/tag/Shipment)|

    |Dry Run: Pick Up Not Completed|`/shipment#dry_run_pickup`|Dry Run: Pick
    Up Not Completed|[Shipment](/v2/tag/Shipment)|

    |Early Delivery Expected|`/shipment#early_delivery_expected`|Early
    Delivery Expected|[Shipment](/v2/tag/Shipment)|

    |EMEA Customs Hold Released|`/shipment#emea_customs_hold_released`|EMEA
    Customs Hold Released|[Shipment](/v2/tag/Shipment)|

    |EMEA Customs Inspection
    Released|`/shipment#emea_customs_inspection_released`|EMEA Customs
    Inspection Released|[Shipment](/v2/tag/Shipment)|

    |Empty Container Not
    Returned|`/shipment#empty_container_not_returned`|Empty Container Not
    Returned|[Shipment](/v2/tag/Shipment)|

    |Shipment Under EPA Exam - Hold Cargo
    Intact|`/shipment#epa_exam_hold_intact`|Shipment Under EPA Exam - Hold
    Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |EPA May Proceed (Released)|`/shipment#epa_may_proceed`|EPA May Proceed
    (Released)|[Shipment](/v2/tag/Shipment)|

    |Shipment Under EPA Review - Hold Cargo
    Intact|`/shipment#epa_review_under_review_hold_cargo_intact`|Shipment
    Under EPA Review - Hold Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |Equipment Unavailable|`/shipment#equipment_unavailable`|Equipment
    Unavailable|[Shipment](/v2/tag/Shipment)|

    |EU Other Government Agency (OGA)
    Hold|`/shipment#eu_other_government_agency_oga_hold`|EU Other Government
    Agency (OGA) Hold|[Shipment](/v2/tag/Shipment)|

    |Export Country Customs
    Exam|`/shipment#export_country_customs_exam`|Export Country Customs
    Exam|[Shipment](/v2/tag/Shipment)|

    |Export Country Magnetism
    Exam|`/shipment#export_country_magnetism_exam`|Export Country Magnetism
    Exam|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Export Customs Cleared|`/shipment#export_customs_cleared`|FID
    63495 - Export Customs Cleared|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Export Customs
    Requested|`/shipment#export_customs_requested`|FID 63495 - Export Customs
    Requested|[Shipment](/v2/tag/Shipment)|

    |Shipment Under FDA Hold - Hold Cargo
    Intact|`/shipment#fda_hold_hold_intact`|Shipment Under FDA Hold - Hold
    Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |FDA May Proceed (Released)|`/shipment#fda_may_proceed`|FDA May Proceed
    (Released)|[Shipment](/v2/tag/Shipment)|

    |Shipment Under Standard FDA Review - Hold Cargo Intact (No Action
    Needed)|`/shipment#fda_review_under_review_hold_cargo_intact`|Shipment
    Under Standard FDA Review - Hold Cargo Intact (No Action
    Needed)|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Delay at
    unloading|`/shipment#fid_63495_delay_at_unloading`|FID 63495 - Delay at
    unloading|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Linehaul arrival
    late|`/shipment#fid_63495_linehaul_arrival_late`|FID 63495 - Linehaul
    arrival late|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Linehaul departure
    late|`/shipment#fid_63495_linehaul_departure_late`|FID 63495 - Linehaul
    departure late|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Pick-up delayed due to late assignment by
    TMC|`/shipment#fid_63495_pick_up_delayed_due_to_late_assignment_by_tmc`|FID
    63495 - Pick-up delayed due to late assignment by
    TMC|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Root cause
    unknown|`/shipment#fid_63495_root_cause_unknown`|FID 63495 - Root cause
    unknown|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Technical problems at LSP (at hub / consolidation
    point)|`/shipment#fid_63495_technical_problems_at_lsp_at_hub_consolidation_point_`|FID
    63495 - Technical problems at LSP (at hub / consolidation
    point)|[Shipment](/v2/tag/Shipment)|

    |Shipment Under Fish & Wildlife (FWS) Hold - Hold Cargo
    Intact|`/shipment#fish_and_wildlife_hold`|Shipment Under Fish & Wildlife
    (FWS) Hold - Hold Cargo Intact|[Shipment](/v2/tag/Shipment)|

    |Fish & Wildlife (FWS)
    Released|`/shipment#fish_and_wildlife_released`|Fish & Wildlife (FWS)
    Released|[Shipment](/v2/tag/Shipment)|

    |Flexport Booking Error|`/shipment#flexport_booking_error`|Flexport
    Booking Error|[Shipment](/v2/tag/Shipment)|

    |Flexport Documentation
    Error|`/shipment#flexport_documentation_error`|Flexport Documentation
    Error|[Shipment](/v2/tag/Shipment)|

    |Flight Delay: Mechanical
    Problem|`/shipment#flight_delay_mechanical`|Flight Delay: Mechanical
    Problem|[Shipment](/v2/tag/Shipment)|

    |Flight Delay: Schedule Updated by
    Carrier|`/shipment#flight_delay_schedule_updated_by_carrier`|Flight Delay:
    Schedule Updated by Carrier|[Shipment](/v2/tag/Shipment)|

    |Goods Damaged|`/shipment#goods_damaged`|Goods
    Damaged|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Goods Damaged at Service
    Center|`/shipment#goods_damaged_at_service_center`|FID 63495 - Goods
    Damaged at Service Center|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Goods Damaged in
    Transit|`/shipment#goods_damaged_in_transit`|FID 63495 - Goods Damaged in
    Transit|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Goods Lost in Transit|`/shipment#goods_lost_in_transit`|FID
    63495 - Goods Lost in Transit|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Goods Missing in
    Transit|`/shipment#goods_missing_in_transit`|FID 63495 - Goods Missing in
    Transit|[Shipment](/v2/tag/Shipment)|

    |US Customs Hold|`/shipment#hold_cbp`|US Customs
    Hold|[Shipment](/v2/tag/Shipment)|

    |Incomplete Shipper
    Onboarding|`/shipment#incomplete_shipper_onboarding`|Incomplete Shipper
    Onboarding|[Shipment](/v2/tag/Shipment)|

    |ISF Not on File|`/shipment#isf_not_on_file`|ISF Not on
    File|[Shipment](/v2/tag/Shipment)|

    |[DO NOT USE]Late House Bill of Lading
    Release|`/shipment#late_bill_of_lading_release`|[DO NOT USE]Late House
    Bill of Lading Release|[Shipment](/v2/tag/Shipment)|

    |LSP Prealert Issue|`/shipment#lsp_prealert_issue`|LSP Prealert
    Issue|[Shipment](/v2/tag/Shipment)|

    |US Customs Manifest Hold|`/shipment#manifest_hold_cbp`|US Customs
    Manifest Hold|[Shipment](/v2/tag/Shipment)|

    |Missed Appointment|`/shipment#missed_appointment`|Missed
    Appointment|[Shipment](/v2/tag/Shipment)|

    |Missing Cargo at Final Destination|`/shipment#missing_cargo`|Missing
    Cargo at Final Destination|[Shipment](/v2/tag/Shipment)|

    |Missing Consignee Commercial Invoice/Packing
    List|`/shipment#missing_consignee_commercial_invoice_packing_list`|Missing
    Consignee Commercial Invoice/Packing List|[Shipment](/v2/tag/Shipment)|

    |Missing Customs Documents|`/shipment#missing_customs_documents`|Missing
    Customs Documents|[Shipment](/v2/tag/Shipment)|

    |Missing Dangerous Goods (DG)
    Document|`/shipment#missing_dangerous_goods_dg_document`|Missing Dangerous
    Goods (DG) Document|[Shipment](/v2/tag/Shipment)|

    |Missing Proof of Delivery
    (POD)|`/shipment#missing_proof_of_delivery_pod_`|Missing Proof of Delivery
    (POD)|[Shipment](/v2/tag/Shipment)|

    |Name of Consignee Unclear|`/shipment#name_of_consignee_unclear`|Name of
    Consignee Unclear|[Shipment](/v2/tag/Shipment)|

    |No Delivery Appointments
    Available|`/shipment#no_appointments_available`|No Delivery Appointments
    Available|[Shipment](/v2/tag/Shipment)|

    |No Attempt Made|`/shipment#no_attempt_made`|No Attempt
    Made|[Shipment](/v2/tag/Shipment)|

    |Ocean Port Dwell Delay|`/shipment#ocean_port_dwell_delay`|Ocean Port
    Dwell Delay|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - On Hand at Destination Service
    Center|`/shipment#on_hand_at_destination_service_center`|FID 63495 - On
    Hand at Destination Service Center|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - On Hand at Hub/Consolidation Center
    Destination|`/shipment#on_hand_at_hub_consolidation_center_destination`|FID
    63495 - On Hand at Hub/Consolidation Center
    Destination|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - On Hand at Hub/Consolidation Center
    Origin|`/shipment#on_hand_at_hub_consolidation_center_origin`|FID 63495 -
    On Hand at Hub/Consolidation Center Origin|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - On Hand at Origin Service
    Center|`/shipment#on_hand_at_origin_service_center`|FID 63495 - On Hand at
    Origin Service Center|[Shipment](/v2/tag/Shipment)|

    |Other Customs Exception|`/shipment#other_customs_exception`|Other Customs
    Exception|[Shipment](/v2/tag/Shipment)|

    |Packaging Issue|`/shipment#packaging_issue`|Packaging
    Issue|[Shipment](/v2/tag/Shipment)|

    |Passed OGA Exam|`/shipment#passed_oga_exam`|Passed OGA
    exam|[Shipment](/v2/tag/Shipment)|

    |Pending Customs Clearance from Nominated
    Broker|`/shipment#pending_customs_clearance_from_nominated_broker`|Pending
    Customs Clearance from Nominated Broker|[Shipment](/v2/tag/Shipment)|

    |Pending Delivery Appointment
    Confirmation|`/shipment#pending_delivery_appointment_confirmation`|Pending
    Delivery Appointment Confirmation|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Pickup Cancelled: Cargo
    Damaged|`/shipment#pickup_cancelled_cargo_damaged`|FID 63495 - Pickup
    Cancelled: Cargo Damaged|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Pickup Cancelled: No Pickup Possible
    |`/shipment#pickup_cancelled_no_pickup_possible`|FID 63495 - Pickup
    Cancelled: No Pickup Possible |[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Pickup Cancelled: Wrong Pickup
    Address|`/shipment#pickup_cancelled_wrong_pickup_address`|FID 63495 -
    Pickup Cancelled: Wrong Pickup Address|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Pickup Delay|`/shipment#pickup_delayed`|FID 63495 - Pickup
    Delay|[Shipment](/v2/tag/Shipment)|

    |Port Strike Delay|`/shipment#port_strike_delay`|Port Strike
    Delay|[Shipment](/v2/tag/Shipment)|

    |Railcar Equipment
    Breakdown|`/shipment#rail_car_equipment_breakdown`|Railcar Equipment
    Breakdown|[Shipment](/v2/tag/Shipment)|

    |Rail Delay: Schedule Updated by
    Carrier|`/shipment#rail_delay_schedule_updated_by_carrier`|Rail Delay:
    Schedule Updated by Carrier|[Shipment](/v2/tag/Shipment)|

    |Rail Interchange Delay|`/shipment#rail_interchange_delay`|Rail
    Interchange Delay|[Shipment](/v2/tag/Shipment)|

    |Rail Transfer Delay|`/shipment#rail_transfer_delay`|Rail Transfer
    Delay|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Cargo Returned to Shipper|`/shipment#returned_to_shipper`|FID
    63495 - Cargo Returned to Shipper|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Security Delay|`/shipment#security_delay`|FID 63495 -
    Security Delay|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Booked with
    Carrier|`/shipment#shipment_booked_with_carrier`|FID 63495 - Shipment
    Booked with Carrier|[Shipment](/v2/tag/Shipment)|

    |Shipment Cancellation
    Requested|`/shipment#shipment_cancellation_requested`|Shipment
    Cancellation Requested|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Cancellation Requested: Post
    Pickup|`/shipment#shipment_cancellation_requested_post_pickup`|FID 63495 -
    Shipment Cancellation Requested: Post Pickup|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Cancellation Requested: Pre
    Pickup|`/shipment#shipment_cancellation_requested_pre_pickup`|FID 63495 -
    Shipment Cancellation Requested: Pre Pickup|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Delay: Force
    Majeure|`/shipment#shipment_delay_force_majeure`|FID 63495 - Shipment
    Delay: Force Majeure|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Delay:
    Holiday|`/shipment#shipment_delay_holiday`|FID 63495 - Shipment Delay:
    Holiday|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Delay: In
    Clarification|`/shipment#shipment_delay_in_clarification`|FID 63495 -
    Shipment Delay: In Clarification|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment Delay: Other
    Reasons|`/shipment#shipment_delay_other_reasons`|FID 63495 - Shipment
    Delay: Other Reasons|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Shipment On Time|`/shipment#shipment_on_time`|FID 63495 -
    Shipment On Time|[Shipment](/v2/tag/Shipment)|

    |Shipment Re-Routed by
    Carrier|`/shipment#shipment_rerouted_by_carrier`|Shipment Re-Routed by
    Carrier|[Shipment](/v2/tag/Shipment)|

    |Shipment Re-Routed per Client
    Request|`/shipment#shipment_rerouted_per_client_request`|Shipment
    Re-Routed per Client Request|[Shipment](/v2/tag/Shipment)|

    |[Ocean Planning]Carrier-Initiated Change Of Vessel / Shipment
    Roll|`/shipment#shipment_rolled_by_carrier`|[Ocean
    Planning]Carrier-Initiated Change Of Vessel / Shipment
    Roll|[Shipment](/v2/tag/Shipment)|

    |Shipment Split|`/shipment#shipment_split`|Shipment
    Split|[Shipment](/v2/tag/Shipment)|

    |Shortage/Overage of Cargo Received at Origin
    CFS|`/shipment#shortage_overage_of_cargo_received_at_origin_cfs`|Shortage/Overage
    of Cargo Received at Origin CFS|[Shipment](/v2/tag/Shipment)|

    |SLA Error/SLA Alignment|`/shipment#sla_error_sla_alignment`|SLA Error/SLA
    Alignment|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Sorting Error|`/shipment#sorting_error`|FID 63495 - Sorting
    Error|[Shipment](/v2/tag/Shipment)|

    |Export Special Handling
    Request|`/shipment#special_handling_request`|Export Special Handling
    Request|[Shipment](/v2/tag/Shipment)|

    |Shipper Late Documents|`/shipment#supplier_late_documents`|Shipper Late
    Documents|[Shipment](/v2/tag/Shipment)|

    |Supplier Late Gate-In|`/shipment#supplier_late_gate_in`|Supplier Late
    Gate-In|[Shipment](/v2/tag/Shipment)|

    |FID 63495 - Tendered To Carrier|`/shipment#tendered_to_carrier`|FID 63495
    - Tendered To Carrier|[Shipment](/v2/tag/Shipment)|

    |Terminal Departure Delay:
    Other|`/shipment#terminal_departure_delay_other`|Terminal Departure Delay:
    Other|[Shipment](/v2/tag/Shipment)|

    |Transload Delay|`/shipment#transload_delay`|Transload
    Delay|[Shipment](/v2/tag/Shipment)|

    |Transshipment Delay|`/shipment#transshipment_delay`|Transshipment
    Delay|[Shipment](/v2/tag/Shipment)|

    |Trucker Rejected|`/shipment#trucker_rejected`|Trucker
    Rejected|[Shipment](/v2/tag/Shipment)|

    |Trucker's Hours Expired|`/shipment#truckers_hours_expired`|Trucker's
    Hours Expired|[Shipment](/v2/tag/Shipment)|

    |Trucking Delay: Chassis
    Problem|`/shipment#trucking_delay_chassis_problem`|Trucking Delay: Chassis
    Problem|[Shipment](/v2/tag/Shipment)|

    |Trucking Delay: Mechanical
    Problem|`/shipment#trucking_delay_mechanical_problem`|Trucking Delay:
    Mechanical Problem|[Shipment](/v2/tag/Shipment)|

    |Trucking Delay: Other|`/shipment#trucking_delay_other`|Trucking Delay:
    Other|[Shipment](/v2/tag/Shipment)|

    |Port congestion. Shipment has been
    delayed|`/shipment#trucking_delay_port_congestion`|Port congestion.
    Shipment has been delayed|[Shipment](/v2/tag/Shipment)|

    |Trucking Delay: Strike|`/shipment#trucking_delay_strike`|Trucking Delay:
    Strike|[Shipment](/v2/tag/Shipment)|

    |Trucking Delay: Traffic|`/shipment#trucking_delay_traffic`|Trucking
    Delay: Traffic|[Shipment](/v2/tag/Shipment)|

    |Unclear/Mismatched Consignee Commercial Invoice/Packing
    List|`/shipment#unclear_mismatched_consignee_commercial_invoice_packing_list`|Unclear/Mismatched
    Consignee Commercial Invoice/Packing List|[Shipment](/v2/tag/Shipment)|

    |Undergoing CPSC|`/shipment#undergoing-cpsc`|Undergoing
    CPSC|[Shipment](/v2/tag/Shipment)|

    |Undergoing FDA Exam|`/shipment#undergoing-fda-exam`|Undergoing FDA
    Exam|[Shipment](/v2/tag/Shipment)|

    |Undergoing USDA|`/shipment#undergoing-usda`|Undergoing
    USDA|[Shipment](/v2/tag/Shipment)|

    |Undergoing OGA Exam|`/shipment#undergoing_oga_exam`|Undergoing OGA
    exam|[Shipment](/v2/tag/Shipment)|

    |Unexpected Flight Cancellation by the
    Carrier|`/shipment#unexpected_flight_cancellation_by_the_carrier`|Unexpected
    Flight Cancellation by the Carrier|[Shipment](/v2/tag/Shipment)|

    |Unknown Customs Hold Type|`/shipment#unknown_customs_hold_type`|Unknown
    Customs Hold Type|[Shipment](/v2/tag/Shipment)|

    |Vessel Delay: Mechanical
    Problem|`/shipment#vessel_delay_mechanical`|Vessel Delay: Mechanical
    Problem|[Shipment](/v2/tag/Shipment)|

    |Vessel Delay: Port
    Congestion|`/shipment#vessel_delay_port_congestion`|Vessel Delay: Port
    Congestion|[Shipment](/v2/tag/Shipment)|

    |Vessel Delay: Ocean Transit Schedule Updated by
    Carrier|`/shipment#vessel_delay_schedule_updated_by_carrier`|Vessel Delay:
    Ocean Transit Schedule Updated by Carrier|[Shipment](/v2/tag/Shipment)|

    |Warehouse Devan Delay|`/shipment#warehouse_devan_delay`|Warehouse Devan
    Delay|[Shipment](/v2/tag/Shipment)|

    |Warehouse: Other|`/shipment#warehouse_other`|Warehouse:
    Other|[Shipment](/v2/tag/Shipment)|

    |Weather delay|`/shipment#weather_delay`|Weather
    delay|[Shipment](/v2/tag/Shipment)|


    ## Invoice Events

    For all Invoice Events, the data field of the Event webhook payload is an
    Invoice Event Data object. There is no direct access from the payload to
    shipment, location, or container information like there is in a Shipment
    Event Data object.


    |Name|Type|Description|

    |----|----|----|

    |Invoice Payment Made|`/invoice#invoice_payment_made`|Invoice payment has
    been made|

    |Invoice Due Date Adjusted|`/invoice#invoice_due_date_adjusted`|Invoice
    payment due date has been adjusted|

    |Invoice Shared|`/invoice#invoice_shared`|Invoice has been shared|

    |Invoice Voided|`/invoice#invoice_voided`|Invoice has been voided|

    |Invoice Credit Applied|`/invoice#invoice_credit_applied`|Invoice credit
    has been applied|

    |Invoice Refund Applied|`/invoice#invoice_refund_applied`|Invoice refund
    has been applied|

    |Invoice Payment Failed|`/invoice#invoice_payment_failed`|Invoice payment
    failed|


    ## Document Events

    For all Document Events, the data field of the Document webhook payload is
    a Document Event Data object. Depending on what the document is connected
    to, the payload may or may not contain shipment information.


    |Name|Type|Description|

    |----|----|----|

    |Document Created*|`/document#document_created`|A document has been
    created|


    ## PurchaseOrder Events

    For all PurchaseOrder Events, the data field of the Event webhook payload
    is a PurchaseOrder Event Data object. It contains PurchaseOrder
    header-level information, as well as context that is unique to each event.

    |Name|Type|Description|

    |----|----|----|

    |PurchaseOrder Acknowledged|`/purchase_order#acknowledged`|PurchaseOrder
    has been acknowledged|

    |PurchaseOrder Updated|`/purchase_order#updated`|PurchaseOrder has been
    updated, currently only supports update through order collaboration flow|


    ## Container Load Result Events

    For all Container Load Result Events, the data field of the Event webhook
    payload is a Container Load Result Event Data object. It contains ids for
    the container load result and associated shipment for each event.

    |Name|Type|Description|

    |----|----|----|

    |Container Load Result Created|`/container_load_result#created`|Container
    Load Result has been created or updated|
- name: Terms and Conditions
  description: >
    [Click here to see the Terms & Conditions for the Flexport
    API](https://www.flexport.com/terms-and-conditions/software_visibility_terms_and_conditions/)
- name: Webhook Endpoints
  x-traitTag: true
  description: >
    Webhook endpoints can be created in your account's Settings section. They
    allow you to be notified of changes

    on your Flexport data and milestone events for your shipments.


    Some webhook events require additional setup by Flexport. Selecting an
    event category in your webhook settings does not

    activate the corresponding capability. See
    [Milestones](/v2/tag/Milestones/) for details, and contact your Flexport

    team if you need these events.


    ## Setting a Secret Token

    Set a secret token for each webhook endpoint. Flexport uses this token as
    the HMAC key to sign

    each request body. Verify the signature before accepting or processing the
    webhook.


    ## Payloads

    The payload for a webhook is an `Event` object.


    Flexport sends both of the following signature headers with each request.
    Use HMAC-SHA256 for

    new integrations and migrate existing integrations from HMAC-SHA1 to
    HMAC-SHA256.


    | Header | Algorithm | Header value format |

    |----|----|----|

    | `X-Hub-Signature-256` | HMAC-SHA256 (recommended) | `sha256=` followed
    by 64 lowercase hexadecimal characters |

    | `X-Hub-Signature` | HMAC-SHA1 (legacy) | `sha1=` followed by 40
    lowercase hexadecimal characters |


    HTTP header names are case-insensitive. Your HTTP server or framework may
    expose them as

    `x-hub-signature-256` and `x-hub-signature`. Use a case-insensitive header
    lookup or your framework's

    normalized header names. The digest is hex-encoded, not base64-encoded,
    and the algorithm prefix

    is part of the header value.


    To validate a payload using HMAC-SHA256:


    1. Read the `X-Hub-Signature-256` header. Reject the request if the header
    is missing or does not
       contain `sha256=` followed by exactly 64 lowercase hexadecimal characters.
    2. Compute the HMAC-SHA256 digest using your endpoint's secret token as
    the key and the raw request
       body bytes as the message. Do not parse and re-serialize the JSON before computing
    the digest:
       changes to whitespace, key order, or encoding will change the signature.
    3. Encode the computed digest as lowercase hexadecimal.

    4. Remove the `sha256=` prefix from the received header value and compare
    the remaining digest
       with your computed digest using a constant-time comparison. Alternatively,
    prepend `sha256=`
       to your computed hexadecimal digest and compare the complete header values
    in constant time.
    5. Accept the webhook only if the signatures match.


    For legacy HMAC-SHA1 verification, follow the same steps using
    `X-Hub-Signature`, HMAC-SHA1,

    the `sha1=` prefix, and a 40-character lowercase hexadecimal digest.


    ## Response

    Flexport expects to receive an HTTP `200` response code from your
    endpoint. We will continue trying to deliver

    the message a number of times if we don’t receive one. To prevent time
    outs, it is wise to configure your

    endpoints to send a `200` and then do any long running processing on the
    data.
- name: Document Types
  x-traitTag: true
  description: >
    Documents can be filtered by type. Below is a list of commonly used
    document types, along with their slug to use for filtering. This list is
    not comprehensive - any `document_type` that is returned from the API is a
    valid parameter for this filter.

    |Document Type|Slug|

    |----|----|

    |90-Day Inspection|90_day_inspection|

    |AEO/ISO Certification|aeo_iso_certification|

    |AFR Worksheet|afr_worksheet|

    |Air Certification for Safe
    Transport|air_certification_for_safe_transport|

    |Air Export SOP|air_export_sop|

    |Air Import SOP|air_import_sop|

    |Air Waybill|air_waybill|

    |Air Waybill Draft|air_waybill_draft|

    |Airline Security (Other Asia Air
    Carriers)|airline_security_other_asia_air_carriers|

    |AMS/ACI Worksheet|ams_aci_worksheet|

    |Animal and Plant Health Inspection Service (APHIS) Plant and Plant
    Product Declaration
    Form|animal_and_plant_health_inspection_service_aphis_plant_and_plant_product_declaration_form|

    |Anti-Corruption Compliance
    Agreement|anti_corruption_compliance_agreement|

    |Approved House Bill of Lading Draft|approved_house_bill_of_lading_draft|

    |Arrival Agent Payment|arrival_agent_payment|

    |Arrival Notice|arrival_notice|

    |Arrival Notice / Invoice|arrival_notice_invoice|

    |Articles of Incorporation|articles_of_incorporation|

    |Australia Customs Entry Form (N10)|australia_customs_entry_form_n10|

    |Australia FCL - Packing Declaration
    Candidate|australia_fcl_packing_declaration_candidate|

    |Australia - Packing Declaration|australia_packing_declaration|

    |Authority To Make Entry|authority_to_make_entry|

    |Automated Export System (AES)
    Transmission|automated_export_system_aes_transmission|

    |Bank Slip|bank_slip|

    |Battery Certification|battery_certification|

    |Bill of Lading|bill_of_lading|

    |Bill of Lading Attachment|bill_of_lading_attachment|

    |Bill of Lading Draft|bill_of_lading_draft|

    |Bill of Lading [Endorsed Original]|bill_of_lading_endorsed_original|

    |Bill of Lading [Telex Release]|bill_of_lading_telex_release|

    |Billing Packet|billing_packet|

    |Bond Package|bond_package|

    |Bond Query|bond_query|

    |Booking Form (CSV)|booking_form_csv|

    |Booking Form (PDF)|booking_form_pdf|

    |Booking Sheet|booking_sheet|

    |Broker to Broker Transportation
    Agreement|broker_to_broker_transportation_agreement|

    |Broker to Motor Carrier Agreement|broker_to_motor_carrier_agreement|

    |BSC Document|bsc_document|

    |Business License|business_license|

    |Business Registration|business_registration|

    |Canada Customs Coding Form (B3)|canada_customs_coding_form_b3|

    |Canada Customs Coding Form (B3)
    Recap|canada_customs_coding_form_b3_recap|

    |Canada Customs Release (RNS)|canada_customs_release_rns|

    |Canada eManifest Close Message|canada_emanifest_close_message|

    |Canada eManifest HBL|canada_emanifest_hbl|

    |Cargo Label|cargo_label|

    |Cargo Manifest|cargo_manifest|

    |Cargo Picture|cargo_picture|

    |Cargo Tracking Note|cargo_tracking_note|

    |Carrier Acceptance Confirmation for DG/NDG
    Declaration|carrier_acceptance_confirmation_for_dg_ndg_declaration|

    |Carrier Contract Amendment|carrier_contract_amendment|

    |Carrier Invoice|carrier_invoice|

    |Carrier invoice for origin services|carrier_invoice_for_origin_services|

    |Carrier Letter of Indemnity|carrier_letter_of_indemnity|

    |Carrier POA|carrier_poa|

    |Certificate of Analysis|certificate_of_analysis|

    |Certificate of Conformity|certificate_of_conformity|

    |Certificate of Insurance|certificate_of_insurance|

    |Certificate of Insurance (Shipment)|certificate_of_insurance_shipment|

    |Certificate of Origin|certificate_of_origin|

    |Certification for Safe Transport of Chemical Goods
    (CHINA)|certification_for_safe_transport_of_chemical_goods_china|

    |China Customs Advanced Manifest|china_customs_advanced_manifest|

    |China Import and Export Goods Declaration
    Form|china_import_and_export_goods_declaration_form|

    |Chinese Tax Invoice (Fapiao)|chinese_tax_invoice_fapiao|

    |CIQ|ciq|

    |Class 9 Receiving Checklist|class_9_receiving_checklist|

    |Client Shipment Request|client_shipment_request|

    |Co-Brokerage Agreement|co_brokerage_agreement|

    |Coloader Booking Form|coloader_booking_form|

    |Combined CI Packet|combined_ci_packet|

    |Commercial Invoice|commercial_invoice|

    |Commercial Invoice / Packing List|commercial_invoice_packing_list|

    |Company CPSC Info|company_cpsc_info|

    |Company FCC Info|company_fcc_info|

    |Company FDA Info|company_fda_info|

    |Consignment Security Declaration|consignment_security_declaration|

    |Consumer Product Safety Commission (CPSC) General Certificate of
    Conformity
    (GCC)|consumer_product_safety_commission_cpsc_general_certificate_of_conformity_gcc|

    |Container Loading Pictures|container_loading_pictures|

    |Container Loading Plan|container_loading_plan|

    |Convention on International Trade in Endangered Species of Wild Fauna and
    Flora (CITES)
    Permit|convention_on_international_trade_in_endangered_species_of_wild_fauna_and_flora_cites_permit|

    |CPSC Info|cpsc_info|

    |Credit Application|credit_application|

    |Credit Approval|credit_approval|

    |CTPAT Container Checklist|ctpat_container_checklist|

    |CUSTOMS_Billing Invoice|customs_billing_invoice|

    |Customs Billing Packet|customs_billing_packet|

    |Customs Broker Packet|customs_broker_packet|

    |Customs Clearance|customs_clearance|

    |Customs Duty|customs_duty|

    |Customs Entry Packet|customs_entry_packet|

    |Customs Entry Summary (7501)|customs_entry_summary_7501|

    |Customs Entry Summary (US 7501/EU Duty Bill
    equivalent)|customs_entry_summary_us_7501_eu_duty_bill_equivalent|

    |Customs EU T Documents Agreement|customs_eu_t_documents_agreement|

    |Customs EU T Documents Guarantee|customs_eu_t_documents_guarantee|

    |Customs FDA Document|customs_fda_document|

    |Customs Footwear Declaration|customs_footwear_declaration|

    |Customs Form 28 (CF-28) Request for
    Information|customs_form_28_cf_28_request_for_information|

    |Customs Form 29 (CF-29) Notice of
    Action|customs_form_29_cf_29_notice_of_action|

    |Customs HS7 for US Department of
    Transportation|customs_hs7_for_us_department_of_transportation|

    |Customs Lacey Declaration|customs_lacey_declaration|

    |Customs Release (3461)|customs_release_3461|

    |Customs Release (US 3461/EU SAD
    equivalent)|customs_release_us_3461_eu_sad_equivalent|

    |Customs Toxic Substance Control Act
    Declaration|customs_toxic_substance_control_act_declaration|

    |Customs US Fish and Wildlife Service Form
    3-177|customs_us_fish_and_wildlife_service_form_3_177|

    |Customs Us Ftz Entry (3461) NetChb
    Upload|customs_us_ftz_entry_3461_netchb_upload|

    |Customs Us Ftz Entry (7501) NetChb
    Upload|customs_us_ftz_entry_7501_netchb_upload|

    |Damage Photos|damage_photos|

    |Dangerous Goods Inspection
    Checklist|dangerous_goods_inspection_checklist|

    |Delivery Order (DO)|delivery_order_do|

    |Delivery SOP|delivery_sop|

    |Denied Parties Proof|denied_parties_proof|

    |Devan Report|devan_report|

    |Direct Representation|direct_representation|

    |Draft Commercial Invoice|draft_commercial_invoice|

    |Draft Commercial Invoice / Packing
    List|draft_commercial_invoice_packing_list|

    |Draft Container Loading Plan|draft_container_loading_plan|

    |Draft Dangerous Goods Declaration|draft_dangerous_goods_declaration|

    |Draft Packing List|draft_packing_list|

    |Drawback 4811|drawback_4811|

    |Drawback Application|drawback_application|

    |Drawback One Time Waiver|drawback_one_time_waiver|

    |Drawback Ruling|drawback_ruling|

    |Drawback Services Agreement|drawback_services_agreement|

    |Drawback Supporting Document|drawback_supporting_document|

    |Driver's License|driver_s_license|

    |DVIR|dvir|

    |ECTN/CTN Document|ectn_ctn_document|

    |Email Correspondence|email_correspondence|

    |Environmental Protection Agency (EPA) Form
    3540-8|environmental_protection_agency_epa_form_3540_8|

    |Environmental Protection Agency (EPA) Formaldehyde Emission Standards for
    Composite Wood
    Products|environmental_protection_agency_epa_formaldehyde_emission_standards_for_composite_wood_products|

    |EU Business Registration|eu_business_registration|

    |EU Customs Duties Bill|eu_customs_duties_bill|

    |EU Customs Export Document (EAD)|eu_customs_export_document_ead|

    |EU Customs Inspection Documents|eu_customs_inspection_documents|

    |EU Customs Release (SAD)|eu_customs_release_sad|

    |EU Declaration of Conformity|eu_declaration_of_conformity|

    |EU FLEGT License|eu_flegt_license|

    |EU Known Consignor (KC) Verification|eu_known_consignor_kc_verification|

    |EU Movement Under Bond (T1)|eu_movement_under_bond_t1|

    |EU Operator's Licence|eu_operator_s_licence|

    |EU Regulated Agent Authorization|eu_regulated_agent_authorization|

    |EU Regulated Agent (RA) Verification|eu_regulated_agent_ra_verification|

    |Evidence of Insurance|evidence_of_insurance|

    |Evidence of Insurance (Shipment)|evidence_of_insurance_shipment|

    |Exam Notice|exam_notice|

    |Export Commercial Invoice|export_commercial_invoice|

    |Export Commercial Invoice / Packing
    List|export_commercial_invoice_packing_list|

    |Export Customs Declaration|export_customs_declaration|

    |Export Customs Pre-Manifest|export_customs_pre_manifest|

    |Export Customs Release Notice|export_customs_release_notice|

    |Export License|export_license|

    |Exporter's Statement of Origin|exporter_s_statement_of_origin|

    |Fabric Detail Sheet|fabric_detail_sheet|

    |FCC Info|fcc_info|

    |FDA Info|fda_info|

    |Federal Fish and Wildlife (FWS)
    Permit|federal_fish_and_wildlife_fws_permit|

    |FERI Document|feri_document|

    |First Sale Invoice|first_sale_invoice|

    |Fiscal Representation|fiscal_representation|

    |Fish and Wildlife Service (FWS) Designated Port Exception
    Permit|fish_and_wildlife_service_fws_designated_port_exception_permit|

    |Fish and Wildlife Service (FWS) eDec Submission
    Confirmation|fish_and_wildlife_service_fws_edec_submission_confirmation|

    |Fish and Wildlife Service (FWS) Payment
    Confirmation|fish_and_wildlife_service_fws_payment_confirmation|

    |Flexport Arrival Notice|flexport_arrival_notice|

    |Flexport Bill of Lading|flexport_bill_of_lading|

    |Flexport EU Power of Attorney|flexport_eu_power_of_attorney|

    |Flexport Original Bill Of Lading|flexport_original_bill_of_lading|

    |Flexport OSRA Demurrage and Detention Invoice
    Addendum|flexport_osra_demurrage_and_detention_invoice_addendum|

    |Flexport Sailing Advisement|flexport_sailing_advisement|

    |Flexport Space Reservation|flexport_space_reservation|

    |Flexport Warehouse Manifest|flexport_warehouse_manifest|

    |Food and Drug Administration (FDA) Impact Resistance Test
    Results|food_and_drug_administration_fda_impact_resistance_test_results|

    |Food and Drug Administration (FDA) Intended Use
    Statement|food_and_drug_administration_fda_intended_use_statement|

    |Food and Drug Administration (FDA) Notice of
    Action|food_and_drug_administration_fda_notice_of_action|

    |Food and Drug Administration (FDA) Registration
    Certificate|food_and_drug_administration_fda_registration_certificate|

    |Foreign Power of Attorney|foreign_power_of_attorney|

    |Forwarder's Cargo Receipt|forwarder_s_cargo_receipt|

    |Forwarder's Certificate of Receipt|forwarder_s_certificate_of_receipt|

    |Freight Forwarder Invoice|freight_forwarder_invoice|

    |Freight Forwarder Payment|freight_forwarder_payment|

    |Freight Forwarder Quote|freight_forwarder_quote|

    |Freight Release|freight_release|

    |Fumigation Certificate|fumigation_certificate|

    |General|general|

    |General Taxpayer Certificate|general_taxpayer_certificate|

    |Haiti Hope II Visa Application|haiti_hope_ii_visa_application|

    |Handling Instructions|handling_instructions|

    |HK Account Consignor Declaration of
    Compliance|hk_account_consignor_declaration_of_compliance|

    |HK Export/Re-export Declaration Form
    2|hk_export_re_export_declaration_form_2|

    |HK Import Declaration Form 1|hk_import_declaration_form_1|

    |HK Known Consignor Declaration of
    Compliance|hk_known_consignor_declaration_of_compliance|

    |House Bill of Lading Draft|house_bill_of_lading_draft|

    |IAC KNOWN Cargo Certification|iac_known_cargo_certification|

    |IAC UNKNOWN Cargo Certification|iac_unknown_cargo_certification|

    |Import License|import_license|

    |Importer Security Filing (ISF) Entry|importer_security_filing_isf_entry|

    |Indirect Representation|indirect_representation|

    |Inland Arrival Notice|inland_arrival_notice|

    |Insurance Declination Form|insurance_declination_form|

    |Insurance Policy|insurance_policy|

    |Insurance Pre-Claim|insurance_pre_claim|

    |Insurance Review|insurance_review|

    |Interim Footwear Invoice|interim_footwear_invoice|

    |IRS Notice|irs_notice|

    |ISC Payment Receipt|isc_payment_receipt|

    |ISF Worksheet|isf_worksheet|

    |Known Shipper Management System|known_shipper_management_system|

    |KSMS Shipper Status: KNOWN|ksms_shipper_status_known|

    |KSMS Shipper Status: UNKNOWN|ksms_shipper_status_unknown|

    |Letter of Donation|letter_of_donation|

    |Letter of Indemnity (LOI)|letter_of_indemnity_loi|

    |Letter of Indemnity (LOI) for lost
    OBL|letter_of_indemnity_loi_for_lost_obl|

    |Letter of Indemnity (LOI) for non-DG|letter_of_indemnity_loi_for_non_dg|

    |Letter of Indemnity (LOI) for Telex
    release|letter_of_indemnity_loi_for_telex_release|

    |Letter of Indemnity - Return Cargo|letter_of_indemnity_return_cargo|

    |Lithium Battery Declaration|lithium_battery_declaration|

    |Lithium Battery Receiving Checklist|lithium_battery_receiving_checklist|

    |Lithium Battery Transportation
    Document|lithium_battery_transportation_document|

    |Magnetic Testing Report|magnetic_testing_report|

    |Manufacturer's Affidavit|manufacturer_s_affidavit|

    |Master Air Waybill|master_air_waybill|

    |Master Air Waybill Draft|master_air_waybill_draft|

    |Master Bill of Lading|master_bill_of_lading|

    |Master Bill of Lading Draft|master_bill_of_lading_draft|

    |Master Bill of Lading [Endorsed
    Original]|master_bill_of_lading_endorsed_original|

    |Master Bill of Lading [Telex
    Release]|master_bill_of_lading_telex_release|

    |Master House Bill of Lading|master_house_bill_of_lading|

    |Master House Bill of Lading Draft|master_house_bill_of_lading_draft|

    |Master House Bill of Lading [Endorsed
    Original]|master_house_bill_of_lading_endorsed_original|

    |Master House Bill of Lading [Telex
    Release]|master_house_bill_of_lading_telex_release|

    |Material Safety Data Sheet (MSDS)|material_safety_data_sheet_msds|

    |Medical Certification|medical_certification|

    |Message Inline Image|message_inline_image|

    |Misc Entry Document|misc_entry_document|

    |Motor Vehicle Record (MVR)|motor_vehicle_record_mvr|

    |National Highway Traffic Safety Administration (NHTSA) HS-7
    Declaration|national_highway_traffic_safety_administration_nhtsa_hs_7_declaration|

    |New Zealand FCL - Packing
    Declaration|new_zealand_fcl_packing_declaration|

    |New Zealand FCL - Packing Declaration
    Candidate|new_zealand_fcl_packing_declaration_candidate|

    |Non-Disclosure Agreement|non_disclosure_agreement|

    |Non-Flexport Power of Attorney|non_flexport_power_of_attorney|

    |NRA|nra|

    |NRA Authorization|nra_authorization|

    |Ocean Export SOP|ocean_export_sop|

    |Ocean Import SOP|ocean_import_sop|

    |Offline Booking Form (CSV)|offline_booking_form_csv|

    |Offline Booking Form (PDF)|offline_booking_form_pdf|

    |Onboarding SOP|onboarding_sop|

    |Origin cargo receipt|origin_cargo_receipt|

    |Origin Fee Invoice Provided by
    Shipper|origin_fee_invoice_provided_by_shipper|

    |Origin Warehouse Receipt|origin_warehouse_receipt|

    |Other|other|

    |Other Customs Documents|other_customs_documents|

    |Outbound Plan|outbound_plan|

    |Packing List|packing_list|

    |Partner Banking Information|partner_banking_information|

    |Partner Bill|partner_bill|

    |Partner Contact List|partner_contact_list|

    |Payment Method Terms and Conditions
    Agreement|payment_method_terms_and_conditions_agreement|

    |Permit To Transfer|permit_to_transfer|

    |Photo|photo|

    |Photo ID|photo_id|

    |Phytosanitary Certificate|phytosanitary_certificate|

    |Port Call Confirmation for AMS & ISF5
    filing|port_call_confirmation_for_ams_isf5_filing|

    |Port Exit Release|port_exit_release|

    |Power of Attorney|power_of_attorney|

    |Power of Attorney Addendum|power_of_attorney_addendum|

    |Pre-Alert|pre_alert|

    |Pre-Alert Instructions|pre_alert_instructions|

    |Pro Forma Invoice|pro_forma_invoice|

    |Product List|product_list|

    |Profile Photo|profile_photo|

    |Proof|proof|

    |Proof of Delivery (POD)|proof_of_delivery_pod|

    |Proof Of Delivery (POD) Candidate|proof_of_delivery_pod_candidate|

    |Proof of EU Port Filing|proof_of_eu_port_filing|

    |Proof of Insurance|proof_of_insurance|

    |Proof of Passthrough|proof_of_passthrough|

    |Proof of Vehicle Insurance|proof_of_vehicle_insurance|

    |Purchase Order|purchase_order|

    |Quality Control Document|quality_control_document|

    |Rated Commercial Invoice|rated_commercial_invoice|

    |Redacted Packing List|redacted_packing_list|

    |RFQ / RFP Final Bid|rfq_rfp_final_bid|

    |Sea/Air Certification for Safe
    Transport|sea_air_certification_for_safe_transport|

    |Sea Certification for Safe
    Transport|sea_certification_for_safe_transport|

    |Secondary Photo ID|secondary_photo_id|

    |Segregation Work Order|segregation_work_order|

    |Shipper Onboarding Questionnaire|shipper_onboarding_questionnaire|

    |Shipper's Bank Slip|shipper_s_bank_slip|

    |Shipper's Declaration for Dangerous
    Goods|shipper_s_declaration_for_dangerous_goods|

    |Shipper's Declaration of Dangerous
    Goods|shipper_s_declaration_of_dangerous_goods|

    |Shipper's Letter of Instructions|shipper_s_letter_of_instructions|

    |Shipper's Letter of Instructions
    (SLI)|shipper_s_letter_of_instructions_sli|

    |Shipper Security Endorsement|shipper_security_endorsement|

    |Shipping Instructions|shipping_instructions|

    |Shipping Labels|shipping_labels|

    |Shipping Order|shipping_order|

    |Social Security Card|social_security_card|

    |Strategic Commodities LOI|strategic_commodities_loi|

    |T2-Transit Accompanying Document|t2_transit_accompanying_document|

    |T86 Manifest|t86_manifest|

    |Telex Release LOI Confirmation
    Letter|telex_release_loi_confirmation_letter|

    |Temp Rel Doc For Inclusion Into Entry
    Packet|temp_rel_doc_for_inclusion_into_entry_packet|

    |Trade Advisory Services Agreement|trade_advisory_services_agreement|

    |Transaction Value Worksheet|transaction_value_worksheet|

    |Transit Paper Agreement|transit_paper_agreement|

    |Transport Document for Li Batteries (Thailand
    Only)|transport_document_for_li_batteries_thailand_only|

    |Transportation Entry and Manifest of Goods Subject to CBP Inspection and
    Permit Form
    (7512)|transportation_entry_and_manifest_of_goods_subject_to_cbp_inspection_and_permit_form_7512|

    |Transportation Worker Identification Credential
[...]
